﻿//########################
//InDesignCS4で画像をドキュメントに配置しドキュメントを適切なサイズに変更し保存します。
//たけうちとおる
//########################
//ダイアログ表示のおまじない
app.scriptPreferences.userInteractionLevel=1699311169;

main();

function main(){
	var selFile = File.openDialog("ファイルを選択してください（複数選択可）","",true);
	if(selFile == null){
		return;
	}
	var selfilecount = selFile.length;
	var pdfFlg = false;
	for(var f = 0;f < selfilecount;f++){
		var extname = getext(selFile[f].fullName);
		if(extname == "pdf" || extname == "ai"){
			pdfFlg = true;
		}
	}
	if(pdfFlg == true){
		if(pdfdialog() == -1){
			return;
		}
	}
	for(var f = 0;f < selfilecount;f++){
		var fsname = selFile[f].fsName + ".indd";
		var fileObj = new File(fsname);
		var myDocu = app.documents.add();
		fileplace(myDocu,selFile[f])
	}
	myDocu.save(fileObj);
}

function fileplace(myDocu,selFile){
	var rectObj = myDocu.pages[0].rectangles.add();
	rectObj.strokeWeight = 0;
	var placeobj = rectObj.place(selFile);
	var placeobjB = rectObj.allGraphics[0].geometricBounds;
	var myW = placeobjB[3] - placeobjB[1];
	var myH = placeobjB[2] - placeobjB[0];
	
	if(myH > myW){
		//縦長
		if(297 > myH && 210 > myW){
			var pageW = 210;var pageH = 297;//A4
		}else if(364 > myH && 257 > myW){
			var pageW = 257;var pageH = 364;//B4
		}else if(420 > myH && 297 > myW){
			var pageW = 297;var pageH = 420;//A3
		}else{
			var pageW = myW;var pageH = myH;//else
		}
	}else{
		//ヨコ長
		if(297 > myW && 210 > myH){
			var pageH = 210;var pageW = 297;//A4
		}else if(364 > myW && 257 > myH){
			var pageH = 257;var pageW = 364;//B4
		}else if(420 > myW && 297 > myH){
			var pageH = 297;var pageW = 420;//A3
		}else{
			var pageW = myW;var pageH = myH;//else
		}
	}
	myDocu.documentPreferences.pageWidth = pageW;
	myDocu.documentPreferences.pageHeight = pageH;
	myDocu.documentPreferences.pagesPerDocument = 1;
	myDocu.documentPreferences.facingPages  = false;
	rectObj.geometricBounds = new Array(0,0,pageH,pageW);

	rectObj.fit (FitOptions.CENTER_CONTENT);
	rectObj.fit (FitOptions.FRAME_TO_CONTENT);
	maketombo(rectObj);
}


//拡張子をトル
function getext(filename){
	var flg = true;
	var extname = "";
	for(i = filename.length-1;i > -1;i--){
		myCha = filename[i];
		if(myCha == "."){
			flg = false;
			break;
		}
		if(flg){
			extname = myCha+extname;
		}
	}
	return extname;
}

function pdfdialog(){
	myDialog = app.dialogs.add({name:"PDFの配置方法を選択して下さい。"});
	with(myDialog){
		with(dialogColumns.add()){
			with (dialogRows.add()){
				var pdfplaceopt = 1;
				staticTexts.add({staticLabel:"トリミング"});
				var Listpdfplaceopt = new Array("バウンディングボックス","アート","トリミング","トンボ","裁ち落とし","メディア");
				var d_pdfplaceopt = dropdowns.add({stringList:Listpdfplaceopt, selectedIndex:pdfplaceopt, minWidth:120});
			}
			staticTexts.add({staticLabel:"(C)2009 Toru Takeuchi このスクリプトはフリーウェアです。"});
		}
	}
	var myReturn = myDialog.show();
	if (myReturn == true){
		//トリミング　バウンディングボックス=0　アート=1 　トリミング=2　トンボ=3　裁ち落とし=4　メディア=5
		pdfplaceopt = d_pdfplaceopt.selectedIndex;
		if(pdfplaceopt == 0){
			app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_CONTENT;	//1131573315	バウンディングボックス
		}else if(pdfplaceopt == 1){
			app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_ART;//アート
		}else if(pdfplaceopt == 2){
			app.pdfPlacePreferences.pdfCrop = PDFCrop.ROP_PDF;//	1131573328	トリミング
		}else if(pdfplaceopt == 3){
			app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_TRIM;//	1131573332	トンボ
		}else if(pdfplaceopt == 4){
			app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_BLEED;//	1131573314	裁ち落とし
		}else if(pdfplaceopt == 5){
			app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_MEDIA;//	1131573325	メディア
		}
		return pdfplaceopt;
	}else{
		return -1;
	}
}



function maketombo(selObj){
lineW=0.05;
var myAry=new Array();
var myRegistrationColor = app.activeDocument.colors.item("Registration");
X1 = selObj.geometricBounds[1];
Y1 = selObj.geometricBounds[0];
X2 = selObj.geometricBounds[3];
Y2 = selObj.geometricBounds[2];
W=X2-X1;
H=Y2-Y1;

//左上
myAry[0]=drowLine(X1-13,X1-3,Y1,Y1,lineW,myRegistrationColor);
myAry[1]=drowLine(X1-13,X1,Y1-3,Y1-3,lineW,myRegistrationColor);
myAry[2]=drowLine(X1-3,X1-3,Y1-13,Y1,lineW,myRegistrationColor);
myAry[3]=drowLine(X1,X1,Y1-13,Y1-3,lineW,myRegistrationColor);

//上センター
myAry[4]=drowLine(X1+W/2,X1+W/2,Y1-13,Y1-3,lineW,myRegistrationColor);
myAry[5]=drowLine(X1+W/2-5,X1+W/2+5,Y1-7,Y1-7,lineW,myRegistrationColor);
myAry[6]=drowEllipse(X1+W/2-2,Y1-7-2,4,4,lineW,myRegistrationColor);

//右上
myAry[7]=drowLine(X2+3,X2+13,Y1,Y1,lineW,myRegistrationColor);
myAry[8]=drowLine(X2,X2+13,Y1-3,Y1-3,lineW,myRegistrationColor);
myAry[9]=drowLine(X2+3,X2+3,Y1-13,Y1,lineW,myRegistrationColor);
myAry[10]=drowLine(X2,X2,Y1-13,Y1-3,lineW,myRegistrationColor);
//左センター
myAry[11]=drowLine(X1-13,X1-3,Y1+H/2,Y1+H/2,lineW,myRegistrationColor);
myAry[12]=drowLine(X1-7,X1-7,Y1+H/2-5,Y1+H/2+5,lineW,myRegistrationColor);
myAry[13]=drowEllipse(X1-7-2,Y1+H/2+-2,4,4,lineW,myRegistrationColor);
//右センター
myAry[14]=drowLine(X2+3,X2+13,Y1+H/2,Y1+H/2,lineW,myRegistrationColor);
myAry[15]=drowLine(X2+7,X2+7,Y1+H/2-5,Y1+H/2+5,lineW,myRegistrationColor);
myAry[16]=drowEllipse(X2+7-2,Y1+H/2-2,4,4,lineW,myRegistrationColor);
//左下
myAry[17]=drowLine(X1-13,X1-3,Y2,Y2,lineW,myRegistrationColor);
myAry[18]=drowLine(X1-13,X1,Y2+3,Y2+3,lineW,myRegistrationColor);
myAry[19]=drowLine(X1-3,X1-3,Y2+13,Y2,lineW,myRegistrationColor);
myAry[20]=drowLine(X1,X1,Y2+13,Y2+3,lineW,myRegistrationColor);
//下センター
myAry[21]=drowLine(X1+W/2,X1+W/2,Y2+13,Y2+3,lineW,myRegistrationColor);
myAry[22]=drowLine(X1+W/2-5,X1+W/2+5,Y2+7,Y2+7,lineW,myRegistrationColor);
myAry[23]=drowEllipse(X1+W/2-2,Y2+7-2,4,4,lineW,myRegistrationColor);
//右上
myAry[24]=drowLine(X2+3,X2+13,Y2,Y2,lineW,myRegistrationColor);
myAry[25]=drowLine(X2,X2+13,Y2+3,Y2+3,lineW,myRegistrationColor);
myAry[26]=drowLine(X2+3,X2+3,Y2+13,Y2,lineW,myRegistrationColor);
myAry[27]=drowLine(X2,X2,Y2+13,Y2+3,lineW,myRegistrationColor);

app.activeWindow.activeSpread.groups.add(myAry);
}
function drowLine(X1,X2,Y1,Y2,lineW,myRegistrationColor){
	myLine=app.activeWindow.activeSpread.rectangles.add();
	myLine.paths.item(0).entirePath=[[X1,Y1],[X2,Y2]];
	//myLine.filled=false;//CS2未サポート
	//myLine.stroked=true;//CS2未サポート
	myLine.strokeWeight=lineW;
	myLine.strokeColor=myRegistrationColor;
	return myLine;
}

function drowEllipse(X,Y,W,H,lineW,myRegistrationColor){
	myObj = app.activeWindow.activeSpread.ovals.add();
	myObj.geometricBounds = [Y,X,Y+H,X+W];
	//myObj.filled=false;//CS2未サポート
	//myObj.stroked=true;//CS2未サポート
	myObj.strokeWeight=lineW;
	myObj.strokeColor=myRegistrationColor;
	return myObj;
}